using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Management;
using System.Runtime.InteropServices;
using System.Threading;
using System.Net.Sockets;
using System.IO;
using System.Text;


namespace LeonDown
{
	public class LeonDown : System.ServiceProcess.ServiceBase
	{
		[StructLayout(LayoutKind.Sequential, Pack=1)]
			internal struct TokPriv1Luid
		{
			public int  Count;
			public long  Luid;
			public int  Attr;
		}

		[DllImport("kernel32.dll", ExactSpelling=true) ]
		internal static extern IntPtr GetCurrentProcess();

		[DllImport("advapi32.dll", ExactSpelling=true, SetLastError=true) ]
		internal static extern bool OpenProcessToken( IntPtr h, int acc, ref IntPtr phtok );

		[DllImport("advapi32.dll", SetLastError=true) ]
		internal static extern bool LookupPrivilegeValue( string host, string name, ref long pluid );

		[DllImport("advapi32.dll", ExactSpelling=true, SetLastError=true) ]
		internal static extern bool AdjustTokenPrivileges( IntPtr htok, bool disall,
			ref TokPriv1Luid newst, int len, IntPtr prev, IntPtr relen );

		[DllImport("user32.dll", ExactSpelling=true, SetLastError=true) ]
		internal static extern bool ExitWindowsEx( int flg, int rea );

		[DllImport("Advapi32.dll", ExactSpelling=true, SetLastError=true) ]
		internal static extern bool InitiateSystemShutdownEx ( string MachineName, string Message, 
				int  Timeout, bool forceAppsClosed, bool RebootAfterShutdown, int Reason);



		internal const int  SE_PRIVILEGE_ENABLED = 0x00000002;
		internal const int  TOKEN_QUERY    = 0x00000008;
		internal const int  TOKEN_ADJUST_PRIVILEGES = 0x00000020;
		internal const string SE_SHUTDOWN_NAME  = "SeShutdownPrivilege";
		internal const int  EWX_LOGOFF    = 0x00000000;
		internal const int  EWX_SHUTDOWN   = 0x00000001;
		internal const int  EWX_REBOOT    = 0x00000002;
		internal const int  EWX_FORCE    = 0x00000004;
		internal const int  EWX_POWEROFF   = 0x00000008;
		internal const int  EWX_FORCEIFHUNG   = 0x00000010;


		System.Threading.Thread thr;
		private System.Diagnostics.Process process1;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LeonDown()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call
		}

		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// More than one user Service may run within the same process. To add
			// another service to this process, change the following line to
			// create a second service object. For example,
			//
			//   ServicesToRun = new System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new LeonDown() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.process1 = new System.Diagnostics.Process();
			// 
			// process1
			// 
			this.process1.Exited += new System.EventHandler(this.process1_Exited);
			// 
			// LeonDown
			// 
			this.CanHandlePowerEvent = true;
			this.CanPauseAndContinue = true;
			this.CanShutdown = true;
			this.ServiceName = "LeonDown";

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			System.Threading.ThreadStart slisten=new ThreadStart(listen);
			thr= new Thread(slisten);
			thr.Start();
		}
 
		/// <summary>
		/// Stop this service.
		/// </summary>
		protected override void OnStop()
		{
					thr.Abort();
		}

		private void listen()
		{

			TcpListener tcpListener = new TcpListener(20080);
			tcpListener.Start( );
			// keep listening until you send the file
			for (;;)
			{
				Socket socketForClient =
					tcpListener.AcceptSocket( );
				if (socketForClient.Connected)
				{
					string s=readline(socketForClient);
					//StreamWriter f = new StreamWriter("c:/a.txt");
					///f.WriteLine(s);
					///f.WriteLine ("OK");
					if (s.IndexOf("poweroff") > 0)
					{
						DoExitWin(EWX_POWEROFF | EWX_FORCE);
					}
					if (s.IndexOf("reboot") > 0)
					{
						DoExitWin(EWX_REBOOT | EWX_FORCE);
					}
					if (s.IndexOf("logoff") > 0)
					{
						DoExitWin(EWX_LOGOFF | EWX_FORCE);
					}
					
					//f.Close();
					socketForClient.Close( );
				}
			} //end for
		}

		private string readline(Socket s)
		{
			NetworkStream ns=new NetworkStream(s);
			System.IO.StreamReader sr=new System.IO.StreamReader(ns);
			return sr.ReadLine();
		}

		private void DoExitWin( int flg )
		{
			
			bool   ok;
			TokPriv1Luid tp;
			IntPtr hproc = GetCurrentProcess();
			IntPtr htok = IntPtr.Zero;
			ok = OpenProcessToken( hproc, TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, ref htok );
			tp.Count = 1;
			tp.Luid = 0;
			tp.Attr = SE_PRIVILEGE_ENABLED;
			ok = LookupPrivilegeValue( null, SE_SHUTDOWN_NAME, ref tp.Luid );
			ok = AdjustTokenPrivileges( htok, false, ref tp, 0, IntPtr.Zero, IntPtr.Zero );
			ok = ExitWindowsEx (flg , 0x00030001 );
		//	ok = InitiateSystemShutdownEx(
		//			null,       // computer name
		//		"Regular shutdown",           // message to display
		///				1,            // length of time to display
		//		true,      // force closed option
		//		true,  // reboot option
		//		235679           // shutdown reason
		//	);

		}


		private void process1_Exited(object sender, System.EventArgs e)
		{
		
		}	  
	}
}
